import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class Typography extends PApplet {float              DRAGGABLE_SNAP             = 10;
int                GRID_COLUMNS               = 5;

Cursor             gCursor;
ScaffoldEditor     gEditor;
Character[]        gCharacters;
boolean            gHasInited = false;

public void setup
()
{
  size( 800, 420 );
  background( 255, 255, 255 );
  
  gCursor = new Cursor();
  gCharacters = new Character[25];
  
  float widthIncrement = 500.0f / ((float) GRID_COLUMNS + 1 );
  float heightIncrement = 340.0f / ((float) ((int) (26.0f / GRID_COLUMNS)));
 
  gCharacters[0] = new CharacterA( new Vector( widthIncrement, heightIncrement, 0 ) );
  gCharacters[1] = new CharacterB( new Vector( 2 * widthIncrement, heightIncrement, 0 ) );
  gCharacters[2] = new CharacterC( new Vector( 3 * widthIncrement, heightIncrement, 0 ) );
  gCharacters[3] = new CharacterD( new Vector( 4 * widthIncrement, heightIncrement, 0 ) );
  gCharacters[4] = new CharacterE( new Vector( 5 * widthIncrement, heightIncrement, 0 ) );
  gCharacters[5] = new CharacterF( new Vector( widthIncrement, 2 * heightIncrement, 0 ) );
  gCharacters[6] = new CharacterG( new Vector( 2 * widthIncrement, 2 * heightIncrement, 0 ) );
  gCharacters[7] = new CharacterH( new Vector( 3 * widthIncrement, 2 * heightIncrement, 0 ) );
  gCharacters[8] = new CharacterI( new Vector( 4 * widthIncrement, 2 * heightIncrement, 0 ) );
  gCharacters[9] = new CharacterJ( new Vector( 5 * widthIncrement, 2 * heightIncrement, 0 ) );
  gCharacters[10] = new CharacterK( new Vector( widthIncrement, 3 * heightIncrement, 0 ) );
  gCharacters[11] = new CharacterL( new Vector( 2 * widthIncrement, 3 * heightIncrement, 0 ) );
  gCharacters[12] = new CharacterM( new Vector( 3 * widthIncrement, 3 * heightIncrement, 0 ) );
  gCharacters[13] = new CharacterN( new Vector( 4 * widthIncrement, 3 * heightIncrement, 0 ) );
  gCharacters[14] = new CharacterO( new Vector( 5 * widthIncrement, 3 * heightIncrement, 0 ) );
  gCharacters[15] = new CharacterP( new Vector( widthIncrement, 4 * heightIncrement, 0 ) );
  gCharacters[16] = new CharacterQ( new Vector( 2 * widthIncrement, 4 * heightIncrement, 0 ) );
  gCharacters[17] = new CharacterR( new Vector( 3 * widthIncrement, 4 * heightIncrement, 0 ) );
  gCharacters[18] = new CharacterS( new Vector( 4 * widthIncrement, 4 * heightIncrement, 0 ) );
  gCharacters[19] = new CharacterT( new Vector( 5 * widthIncrement, 4 * heightIncrement, 0 ) );
  gCharacters[20] = new CharacterU( new Vector( widthIncrement, 5 * heightIncrement, 0 ) );
  gCharacters[21] = new CharacterV( new Vector( 2 * widthIncrement, 5 * heightIncrement, 0 ) );
  gCharacters[22] = new CharacterW( new Vector( 3 * widthIncrement, 5 * heightIncrement, 0 ) );
  gCharacters[23] = new CharacterX( new Vector( 4 * widthIncrement, 5 * heightIncrement, 0 ) );
  gCharacters[24] = new CharacterY( new Vector( 5 * widthIncrement, 5 * heightIncrement, 0 ) );
  
  gEditor = new ScaffoldEditor( new Vector( 635, 210, 0 ), 180 );
  
  smooth();
}

public void draw
()
{
  if ( !gHasInited ) {
    freshDraw();
    gHasInited = true;
  }
  
  gCursor.update();
  gEditor.update( gCursor );
}

public void freshDraw
()
{
  background( 255 );
  
  strokeCap( PROJECT );
  
  gEditor.draw();
  
  strokeWeight( 3 );
  stroke( 0 );
  strokeCap( ROUND );
  
  for ( int i=0; i<gCharacters.length; i++ )
  {
    gCharacters[i].draw();
  }
}

public void mousePressed
()
{
  gCursor.pressed = true;
}

public void mouseReleased
()
{
  gCursor.pressed = false;
}

abstract class Character
{
  Vector              position;
  CharacterScaffold   scaffold;
  final float         k = 0.2f;

  Character
    ( Vector position )
  {
    this.position = position;
  }

  public void setScaffold
    ( CharacterScaffold scaffold )
  {
    this.scaffold = scaffold;
  }

  public abstract void draw();
}

class CharacterA extends Character
{
  CharacterA
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y, px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y );
    line( px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y, px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y );
    line( px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y, px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y );
    line( px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y, px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y );
    line( px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
    line( px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y, px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y );
  }
}

class CharacterB extends Character
{
  CharacterB
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y );
    line( px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y, px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y );
    line( px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y, px + k * scaffold.vertices[11].x, py + k * scaffold.vertices[11].y );
    line( px + k * scaffold.vertices[11].x, py + k * scaffold.vertices[11].y, px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y );
    line( px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y, px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y );
    line( px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y, px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y );
  }
}

class CharacterC extends Character
{
  CharacterC
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y, px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y );
    line( px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y, px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y );
    line( px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y, px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y );
    line( px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y, px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y );
    line( px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y, px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y );
    line( px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
  }
}


class CharacterD extends Character
{
  CharacterD
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y );
    line( px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y, px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y );
    line( px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y, px + k * scaffold.vertices[11].x, py + k * scaffold.vertices[11].y );
    line( px + k * scaffold.vertices[11].x, py + k * scaffold.vertices[11].y, px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y );
    line( px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y, px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y );
  }
}

class CharacterE extends Character
{
  CharacterE
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y );
    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
    line( px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y, px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y );
  }
}

class CharacterF extends Character
{
  CharacterF
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y, px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y );
    line( px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y, px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y );
    line( px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y, px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y );
  }
}

class CharacterG extends Character
{
  CharacterG
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y, px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y );
    line( px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y, px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y );
    line( px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y, px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y );
    line( px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y, px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y );
    line( px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
    line( px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y, px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y );
  }
}

class CharacterH extends Character
{
  CharacterH
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y, px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y );
    line( px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y, px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y );
  }
}

class CharacterI extends Character
{
  CharacterI
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y );
    line( px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[4].y, px + k * scaffold.vertices[6].x, py + k * scaffold.vertices[6].y );
  }
}

class CharacterJ extends Character
{
  CharacterJ
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y );
    line( px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y, px + k * scaffold.vertices[6].x, py + k * scaffold.vertices[6].y );
    line( px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[4].y, px + k * scaffold.vertices[6].x, py + k * scaffold.vertices[6].y );
    line( px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y, px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y );
    line( px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y, px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y );
  }
}

class CharacterK extends Character
{
  CharacterK
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y, px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y );
    line( px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
  }
}

class CharacterL extends Character
{
  CharacterL
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
  }
}

class CharacterM extends Character
{
  CharacterM
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[6].x, py + k * scaffold.vertices[6].y );
    line( px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y, px + k * scaffold.vertices[6].x, py + k * scaffold.vertices[6].y );
  }
}

class CharacterN extends Character
{
  CharacterN
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
  }
}

class CharacterO extends Character
{
  CharacterO
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y, px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y );
    line( px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y, px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y );
    line( px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y, px + k * scaffold.vertices[11].x, py + k * scaffold.vertices[11].y );
    line( px + k * scaffold.vertices[11].x, py + k * scaffold.vertices[11].y, px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y );
    line( px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y, px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y );
    line( px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y, px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y );
    line( px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y, px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y );
    line( px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y, px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y );
  }
}

class CharacterP extends Character
{
  CharacterP
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y );
    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y, px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y );
    line( px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y, px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y );
    line( px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y, px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y );
  }
}

class CharacterQ extends Character
{
  CharacterQ
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y, px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y );
    line( px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y, px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y );
    line( px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
    line( px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y, px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y );
    line( px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y, px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y );
    line( px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y, px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y );
    line( px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y, px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y );
    line( px, py, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
  }
}

class CharacterR extends Character
{
  CharacterR
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y );
    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y, px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y );
    line( px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y, px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y );
    line( px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y, px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y );
    line( px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
  }
}


class CharacterS extends Character
{
  CharacterS
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y, px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y );
    line( px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y, px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y );
    line( px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y, px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y );
    line( px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y, px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y );
    line( px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y, px + k * scaffold.vertices[11].x, py + k * scaffold.vertices[11].y );
    line( px + k * scaffold.vertices[11].x, py + k * scaffold.vertices[11].y, px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y );
    line( px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
  }
}

class CharacterT extends Character
{
  CharacterT
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y );
    line( px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[4].y, px + k * scaffold.vertices[6].x, py + k * scaffold.vertices[6].y );
  }
}

class CharacterU extends Character
{
  CharacterU
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y );
    line( px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y, px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y );
    line( px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y, px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y );
    line( px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y, px + k * scaffold.vertices[11].x, py + k * scaffold.vertices[11].y );
    line( px + k * scaffold.vertices[11].x, py + k * scaffold.vertices[11].y, px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y );
  }
}

class CharacterV extends Character
{
  CharacterV
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[6].x, py + k * scaffold.vertices[6].y );
    line( px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y, px + k * scaffold.vertices[6].x, py + k * scaffold.vertices[6].y );
  }
}

class CharacterW extends Character
{
  CharacterW
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y, px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[4].y );
    line( px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[4].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
    line( px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y, px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y );
  }
}

class CharacterX extends Character
{
  CharacterX
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[5].y );
    line( px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y, px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[5].y );
    line( px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y, px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[5].y );
    line( px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y, px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[5].y );
  }
}

class CharacterY extends Character
{
  CharacterY
    ( Vector position )
  {
    super( position );
  }

  public void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[5].y );
    line( px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y, px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[5].y );
    line( px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[5].y, px + k * scaffold.vertices[6].x, py + k * scaffold.vertices[6].y );
  }
}
class CharacterScaffold
{
  Vector[] vertices;
  
  CharacterScaffold
  ()
  {
    vertices = new Vector[16];
    
    for ( int i=0; i<vertices.length; i++ )
    {
      vertices[i] = new Vector();
    }
  }
}

class Cursor
{
  Vector     position;
  boolean    pressed;
  boolean    selected;
  
  Cursor
  ()
  {
    position = new Vector();
    pressed = false;
    selected = false;
  }
  
  public void update
  ()
  {
    position.setX( mouseX );
    position.setY( mouseY );
  }
}

class DraggableLine
{
  int     state; // 0 - default, 1 - highlighted, 2 - selected
  Vector  p1;
  Vector  p2;
  Vector  axis;
  Vector  min;
  Vector  max;
  
  DraggableLine
  ( Vector p1,
    Vector p2,
    Vector axis,
    Vector min,
    Vector max )
  {
    this.p1 = p1;
    this.p2 = p2;
    this.axis = axis;
    this.min = min;
    this.max = max;
  }
  
  public boolean update
  ( Cursor   cursor,
    boolean  token )
  {
    float cx = cursor.position.x;
    float cy = cursor.position.y;
    
    float maxx = max( p1.x, p2.x );
    float minx = min( p1.x, p2.x );
    float maxy = max( p1.y, p2.y );
    float miny = min( p1.y, p2.y );
    float z = DRAGGABLE_SNAP;

    if ( token == true )
    {
      state = 0;
      return true;
    }
    
    if ( state == 1 && cursor.pressed && !cursor.selected)
    {
      state = 2;
      cursor.selected = true;
      return true;
    }
    
    if ( state == 2 )
    {
      if ( !cursor.pressed )
      {
        state = 1;
        cursor.selected = false;
        freshDraw();
      }
    }
    else
    {
      Vector diff = p2.sub(p1);
      float d = abs( diff.x * ( p2.y - cy ) - ( p2.x - cx ) * diff.y ) / diff.length();
      
      if ( cx > minx - z && cx < maxx + z && cy > miny - z && cy < maxy + z  && d < z && !cursor.selected )
      {
        state = 1;
        freshDraw();
      }
      else
      {
        if ( state != 0 )
        {
          state = 0;
          freshDraw();
        }
      }
    }
    
    if ( state == 2 )
    {
      Vector diff;
      Vector p3;
      Vector p4;
      Vector p5 = new Vector();
      float  len;
      
      diff = new Vector( cx - p1.x, cy - p1.y, 0 );
      len = diff.dot( axis ) / axis.length();
      
      p3 = p1.add( axis.mul( len ) );
      p4 = p2.add( axis.mul( len ) );
      
      p5.x = ( p3.x < min.x ) ? min.x : p3.x;
      p5.x = ( p3.x > max.x ) ? max.x : p5.x;
      p5.y = ( p3.y < min.y ) ? min.y : p3.y;
      p5.y = ( p3.y > max.y ) ? max.y : p5.y;
     
      p2.x += p5.x - p1.x;
      p2.y += p5.y - p1.y;
      p1.x = p5.x;
      p1.y = p5.y;
    }
    
    if ( state == 1 )
    {
      return true;
    }
    else
    {
      return false;
    }
  }
  
  public void draw
  ()
  {
    switch ( state )
    {
      case 0:
        stroke( 200, 200, 200 ); break;
      case 1:
        stroke( 100, 100, 100 ); break;
      case 2:
        stroke( 200, 0, 0 ); break;
    }
    
    strokeWeight( 5 );
    line( p1.x, p1.y, p2.x, p2.y );
  }
  
  public Vector intersect( DraggableLine line )
  {
    Vector r = new Vector();
    float x1, x2, x3, x4;
    float y1, y2, y3, y4;
    float ua;
    float ub;
    
    x1 = p1.x;
    y1 = p1.y;
    
    x2 = p2.x;
    y2 = p2.y;
    
    x3 = line.p1.x;
    y3 = line.p1.y;
    
    x4 = line.p2.x;
    y4 = line.p2.y;
    
    ua = ((x4 - x3)*(y1 - y3) - (y4-y3)*(x1-x3))/((y4 - y3)*(x2 - x1) - (x4 - x3)*(y2 - y1));
    // ub = ((x2 - x1)*(y1 - y3) - (y2-y1)*(x1-x3))/((y4 - y3)*(x2 - x1) - (x4 - x3)*(y2 - y1));
    
    r.x = x1 + ua * ( x2 - x1 );
    r.y = y1 + ua * ( y2 - y1 );
    
    return r;
  }
}

class ScaffoldEditor
{
  Vector              position;
  
  DraggableLine       heightTop;
  DraggableLine       divHorizontal;
  DraggableLine       heightBottom;
  DraggableLine       widthLeft;
  DraggableLine       divVertical;
  DraggableLine       widthRight;  
  
  DraggableLine       sub0;
  DraggableLine       sub1;
  DraggableLine       sub2;
  DraggableLine       sub3;
  
  CharacterScaffold   scaffold;
  
  ScaffoldEditor
  ( Vector position,
    float  extent )
  {
    this.position      = position;
    
    float px           = position.x;
    float py           = position.y;
    
    heightTop          = new DraggableLine( 
                          new Vector( px - extent/2, py - extent/2, 0 ), 
                          new Vector( px + extent/2, py - extent/2, 0 ), 
                          new Vector( 0, 1, 0 ),
                          new Vector( px - extent/2, py - extent/2, 0 ),
                          new Vector( px + extent/2, py, 0 ) );
    divHorizontal      = new DraggableLine( 
                          new Vector( px - extent/2, py, 0 ), 
                          new Vector( px + extent/2, py, 0 ), 
                          new Vector( 0, 1, 0 ),
                          new Vector( px - extent/2, py - extent/2, 0 ),
                          new Vector( px + extent/2, py + extent/2, 0 ) );
    heightBottom       = new DraggableLine( 
                          new Vector( px - extent/2, py + extent/2, 0 ), 
                          new Vector( px + extent/2, py + extent/2, 0 ), 
                          new Vector( 0, 1, 0 ),
                          new Vector( px - extent/2, py, 0 ),
                          new Vector( px + extent/2, py + extent/2, 0 ) );
    widthLeft          = new DraggableLine( 
                          new Vector( px - extent/2, py - extent/2, 0 ), 
                          new Vector( px - extent/2, py + extent/2, 0 ), 
                          new Vector( 1, 0, 0 ),
                          new Vector( px - extent/2, py - extent/2, 0 ),
                          new Vector( px, py + extent/2, 0 ) );
    divVertical        = new DraggableLine( 
                          new Vector( px, py - extent/2, 0 ), 
                          new Vector( px, py + extent/2, 0 ), 
                          new Vector( 1, 0, 0 ),
                          new Vector( px - extent/2, py - extent/2, 0 ),
                          new Vector( px + extent/2, py + extent/2, 0 ) );
    widthRight         = new DraggableLine( 
                          new Vector( px + extent/2, py - extent/2, 0 ), 
                          new Vector( px + extent/2, py + extent/2, 0 ), 
                          new Vector( 1, 0, 0 ),
                          new Vector( px, py - extent/2, 0 ),
                          new Vector( px + extent/2, py + extent/2, 0 ) );
                          
    sub0               = new DraggableLine( 
                          new Vector( px + extent/8, py - 5*extent/8, 0 ), 
                          new Vector( px + 5*extent/8, py - extent/8, 0 ), 
                          new Vector( 1, -1, 0 ),
                          new Vector( px, py - 3*extent/4, 0 ),
                          new Vector( px + extent/4, py - extent/2, 0 ) );
                          
    sub1               = new DraggableLine( 
                          new Vector( px + extent/8, py + 5*extent/8, 0 ), 
                          new Vector( px + 5*extent/8, py + extent/8, 0 ), 
                          new Vector( 1, 1, 0 ),
                          new Vector( px, py + extent/2, 0 ),
                          new Vector( px + extent/4, py + 3*extent/4, 0 ) );
                          
    sub2               = new DraggableLine( 
                          new Vector( px - extent/8, py + 5*extent/8, 0 ), 
                          new Vector( px - 5*extent/8, py + extent/8, 0 ), 
                          new Vector( 1, -1, 0 ),
                          new Vector( px - extent/4, py + extent/2, 0 ),
                          new Vector( px, py + 3*extent/4, 0 ) );
                          
    sub3               = new DraggableLine( 
                          new Vector( px - extent/8, py - 5*extent/8, 0 ), 
                          new Vector( px - 5*extent/8, py - extent/8, 0 ), 
                          new Vector( 1, 1, 0 ),
                          new Vector( px - extent/4, py - 3*extent/4, 0 ),
                          new Vector( px, py - extent/2, 0 ) );
                          
    scaffold = new CharacterScaffold();
    updateScaffold();
      
    for ( int i=0; i<gCharacters.length; i++ )
    {
      gCharacters[i].setScaffold( scaffold );
    }
  }
  
  public void update
  ( Cursor cursor )
  {
    boolean token = false;
    
    float px = position.x;
    float py = position.y;
    
    token = heightTop.update( cursor, token );
    token = heightBottom.update( cursor, token );
    token = widthLeft.update( cursor, token );
    token = widthRight.update( cursor, token );
    token = divHorizontal.update( cursor, token );
    token = divVertical.update( cursor, token );
    
    token = sub0.update( cursor, token );
    token = sub1.update( cursor, token );
    token = sub2.update( cursor, token );
    token = sub3.update( cursor, token );
    
    if ( cursor.pressed )
    {
      widthLeft.p1.y        = heightTop.p1.y;
      widthRight.p1.y       = heightTop.p1.y;
      widthLeft.p2.y        = heightBottom.p1.y;
      widthRight.p2.y       = heightBottom.p1.y;
      heightTop.p1.x        = widthLeft.p1.x;
      heightBottom.p1.x     = widthLeft.p1.x;
      heightTop.p2.x        = widthRight.p1.x;
      heightBottom.p2.x     = widthRight.p1.x;
      
      divHorizontal.p1.x    = divVertical.min.x = heightTop.p1.x;
      divHorizontal.p2.x    = divVertical.max.x = heightTop.p2.x;
      divVertical.p1.y      = divHorizontal.min.y = widthLeft.p1.y;
      divVertical.p2.y      = divHorizontal.max.y = widthLeft.p2.y;
      
      updateScaffold();

      for ( int i=0; i<gCharacters.length; i++ )
      {
        gCharacters[i].setScaffold( scaffold );
      }
      
      freshDraw();
    }
  }
  
  public void draw
  ()
  {
    float px = position.x;
    float py = position.y;
    
    strokeWeight( 10 );
    stroke( 230 );
    ellipse( px, py, 10, 10 );
    
    heightTop.draw();
    divHorizontal.draw();
    heightBottom.draw();
    widthLeft.draw();
    divVertical.draw();
    widthRight.draw();
    
    sub0.draw();
    sub1.draw();
    sub2.draw();
    sub3.draw();
  }
  
  public void updateScaffold
  ()
  {
    float px = position.x;
    float py = position.y;
    
    scaffold.vertices[0].set( heightTop.p1.x - px, heightTop.p1.y - py, 0 );
    scaffold.vertices[1].set( heightTop.p2.x - px, heightTop.p2.y - py, 0 );
    scaffold.vertices[2].set( heightBottom.p2.x - px, heightBottom.p2.y - py, 0 );
    scaffold.vertices[3].set( heightBottom.p1.x - px, heightBottom.p1.y - py, 0 );
    scaffold.vertices[4].set( divVertical.p1.x - px, divVertical.p1.y - py, 0 );
    scaffold.vertices[5].set( divHorizontal.p2.x - px, divHorizontal.p2.y - py, 0 );
    scaffold.vertices[6].set( divVertical.p2.x - px, divVertical.p2.y - py, 0 );
    scaffold.vertices[7].set( divHorizontal.p1.x - px, divHorizontal.p1.y - py, 0 );
    
    Vector i1 = heightTop.intersect( sub0 );
    Vector i2 = widthRight.intersect( sub0 );
    Vector i3 = widthRight.intersect( sub1 );
    Vector i4 = heightBottom.intersect( sub1 );
    Vector i5 = heightBottom.intersect( sub2 );
    Vector i6 = widthLeft.intersect( sub2 );
    Vector i7 = widthLeft.intersect( sub3 );
    Vector i8 = heightTop.intersect( sub3 );
    
    scaffold.vertices[8].set( i8.x - px, i8.y - py, 0 );
    scaffold.vertices[9].set( i1.x - px, i1.y - py, 0 );
    scaffold.vertices[10].set( i2.x - px, i2.y - py, 0 );
    scaffold.vertices[11].set( i3.x - px, i3.y - py, 0 );
    scaffold.vertices[12].set( i4.x - px, i4.y - py, 0 );
    scaffold.vertices[13].set( i5.x - px, i5.y - py, 0 );
    scaffold.vertices[14].set( i6.x - px, i6.y - py, 0 );
    scaffold.vertices[15].set( i7.x - px, i7.y - py, 0 );
    
    if ( scaffold.vertices[8].x < scaffold.vertices[0].x )
    {
      scaffold.vertices[8].x = scaffold.vertices[15].x = scaffold.vertices[0].x;
      scaffold.vertices[8].y = scaffold.vertices[15].y = scaffold.vertices[0].y;
    } 
    
    if ( scaffold.vertices[9].x > scaffold.vertices[1].x )
    {
      scaffold.vertices[9].x = scaffold.vertices[10].x = scaffold.vertices[1].x;
      scaffold.vertices[9].y = scaffold.vertices[10].y = scaffold.vertices[1].y;
    } 
    
    if ( scaffold.vertices[12].x > scaffold.vertices[2].x )
    {
      scaffold.vertices[12].x = scaffold.vertices[11].x = scaffold.vertices[2].x;
      scaffold.vertices[12].y = scaffold.vertices[11].y = scaffold.vertices[2].y;
    } 
    
    if ( scaffold.vertices[13].x < scaffold.vertices[3].x )
    {
      scaffold.vertices[13].x = scaffold.vertices[14].x = scaffold.vertices[3].x;
      scaffold.vertices[13].y = scaffold.vertices[14].y = scaffold.vertices[3].y;
    } 
  }
}

class Vector
{
  float a;
  float b;
  float c;
  
  float x;
  float y;
  float z;
  
  Vector
  ()
  {
    a = x = 0;
    b = y = 0;
    c = z = 0;
  }
  
  Vector
  ( float a,
    float b,
    float c )
  {
    this.a = this.x = a;
    this.b = this.y = b;
    this.c = this.z = c;
  }
  
  public void setA
  ( float x )
  {
    this.a = this.x = x;
  }
  
  public void setB
  ( float y )
  {
    this.b = this.y = y;
  }
  
  public void setC
  ( float z )
  {
    this.c = this.z = z;
  }
  
  public void setX
  ( float x )
  {
    this.a = this.x = x;
  }
  
  public void setY
  ( float y )
  {
    this.b = this.y = y;
  }
  
  public void setZ
  ( float z )
  {
    this.c = this.z = z;
  }
  
  public void set
  ( Vector v )
  {
    this.setA( v.a );
    this.setB( v.b );
  }
  
  public void set
  ( float x,
    float y,
    float z )
  {
    this.setA( x );
    this.setB( y );
    this.setC( z );
  }
  
  public float length
  ()
  {
    return sqrt( x * x + y * y + z * z );
  }
  
  public float length2
  ()
  {
    return x * x + y * y + z * z;
  }
  
  public Vector normalise
  ()
  {
    Vector r = new Vector();
    float length = length();
    
    r.setA( x / length );
    r.setB( y / length );
    r.setC( z / length );
    
    return r;
  }
  
  public Vector cross
  ( Vector v )
  {
    Vector r = new Vector();
    
    r.set( this.y * v.z - this.z * v.y,
           this.z * v.x - this.x * v.z,
           this.x * v.y - this.y * v.x );
    
    return r;
  }
  
  public float dot
  ( Vector v )
  {
    float r = 0;
    
    r = this.x * v.x +
        this.y * v.y +
        this.z * v.z;
    
    return r;
  }
  
  public Vector mul
  ( float k )
  {
    Vector r = new Vector();
    
    r.set( this.x * k,
           this.y * k,
           this.z * k );
           
    return r;
  }
  
  public Vector add
  ( Vector v )
  {
    Vector r = new Vector();
    
    r.set( this.x + v.x,
           this.y + v.y,
           this.z + v.z );
           
    return r;
  }
  
  public Vector sub
  ( Vector v )
  {
    Vector r = new Vector();
    
    r.set( this.x - v.x,
           this.y - v.y,
           this.z - v.z );
           
    return r;
  }
  
  public Vector arbitraryRotate
  ( Vector a,
    float theta )
  {
    Vector r = new Vector();    
    float costheta = cos(theta);
    float sintheta = sin(theta);
    
    a = a.normalise();

    r.x += (costheta + (1 - costheta) * a.x * a.x) * this.x;
    r.x += ((1 - costheta) * a.x * a.y - a.z * sintheta) * this.y;
    r.x += ((1 - costheta) * a.x * a.z + a.y * sintheta) * this.z;

    r.y += ((1 - costheta) * a.x * a.y + a.z * sintheta) * this.x;
    r.y += (costheta + (1 - costheta) * a.y * a.y) * this.y;
    r.y += ((1 - costheta) * a.y * a.z - a.x * sintheta) * this.z;

    r.z += ((1 - costheta) * a.x * a.z - a.y * sintheta) * this.x;
    r.z += ((1 - costheta) * a.y * a.z + a.x * sintheta) * this.y;
    r.z += (costheta + (1 - costheta) * a.z * a.z) * this.z;
    
    return r;
  }
}

  static public void main(String args[]) {     PApplet.main(new String[] { "Typography" });  }}