// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2008  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Apologies for the lack of comments and the horrible code structure. I will fix
// this soon. If you have any questions feel free to email me at:
// ali@arkitus.com
// ------------------------------------------------------------------------------

class Vector
{
  float a;
  float b;
  float c;
  
  float x;
  float y;
  float z;
  
  Vector
  ()
  {
    a = x = 0;
    b = y = 0;
    c = z = 0;
  }
  
  Vector
  ( float a,
    float b,
    float c )
  {
    this.a = this.x = a;
    this.b = this.y = b;
    this.c = this.z = c;
  }
  
  void setA
  ( float x )
  {
    this.a = this.x = x;
  }
  
  void setB
  ( float y )
  {
    this.b = this.y = y;
  }
  
  void setC
  ( float z )
  {
    this.c = this.z = z;
  }
  
  void setX
  ( float x )
  {
    this.a = this.x = x;
  }
  
  void setY
  ( float y )
  {
    this.b = this.y = y;
  }
  
  void setZ
  ( float z )
  {
    this.c = this.z = z;
  }
  
  void set
  ( Vector v )
  {
    this.setA( v.a );
    this.setB( v.b );
  }
  
  void set
  ( float x,
    float y,
    float z )
  {
    this.setA( x );
    this.setB( y );
    this.setC( z );
  }
  
  float length
  ()
  {
    return sqrt( x * x + y * y + z * z );
  }
  
  float length2
  ()
  {
    return x * x + y * y + z * z;
  }
  
  Vector normalise
  ()
  {
    Vector r = new Vector();
    float length = length();
    
    r.setA( x / length );
    r.setB( y / length );
    r.setC( z / length );
    
    return r;
  }
  
  Vector cross
  ( Vector v )
  {
    Vector r = new Vector();
    
    r.set( this.y * v.z - this.z * v.y,
           this.z * v.x - this.x * v.z,
           this.x * v.y - this.y * v.x );
    
    return r;
  }
  
  float dot
  ( Vector v )
  {
    float r = 0;
    
    r = this.x * v.x +
        this.y * v.y +
        this.z * v.z;
    
    return r;
  }
  
  Vector mul
  ( float k )
  {
    Vector r = new Vector();
    
    r.set( this.x * k,
           this.y * k,
           this.z * k );
           
    return r;
  }
  
  Vector add
  ( Vector v )
  {
    Vector r = new Vector();
    
    r.set( this.x + v.x,
           this.y + v.y,
           this.z + v.z );
           
    return r;
  }
  
  Vector sub
  ( Vector v )
  {
    Vector r = new Vector();
    
    r.set( this.x - v.x,
           this.y - v.y,
           this.z - v.z );
           
    return r;
  }
  
  Vector arbitraryRotate
  ( Vector a,
    float theta )
  {
    Vector r = new Vector();    
    float costheta = cos(theta);
    float sintheta = sin(theta);
    
    a = a.normalise();

    r.x += (costheta + (1 - costheta) * a.x * a.x) * this.x;
    r.x += ((1 - costheta) * a.x * a.y - a.z * sintheta) * this.y;
    r.x += ((1 - costheta) * a.x * a.z + a.y * sintheta) * this.z;

    r.y += ((1 - costheta) * a.x * a.y + a.z * sintheta) * this.x;
    r.y += (costheta + (1 - costheta) * a.y * a.y) * this.y;
    r.y += ((1 - costheta) * a.y * a.z - a.x * sintheta) * this.z;

    r.z += ((1 - costheta) * a.x * a.z - a.y * sintheta) * this.x;
    r.z += ((1 - costheta) * a.y * a.z + a.x * sintheta) * this.y;
    r.z += (costheta + (1 - costheta) * a.z * a.z) * this.z;
    
    return r;
  }
}
